
require "./module"

module DocMachine::Write::Nodes
  class RootNode
    property context : String = ""
    property audience : String = ""
    property goals : String = ""
    property constraints : String = ""
    property chapters = [] of ChapterNode

    def build_chapters()
      [] of ChapterNode
    end
  end

  class ChapterNode
    property sections = [] of SectionNode

    def build_sections()
      [] of SectionNode
    end
  end

  class SectionNode
    property subsections = [] of SubsectionNode

    def build_subsections()
      [] of SubsectionNode
    end
  end

  class SubsectionNode
    property content = [] of String

    def build_content()
      [] of String
    end

    def fix_content()
      [] of String
    end
  end
end


